#include <stdio.h>
#include <signal.h>
#include "pvmuser.h"

int tw_node_num;
int tw_num_nodes;

#define HOST_LEN 32
#define MAX_NODES 24

static char host[MAX_NODES + 1][HOST_LEN];

char sunname[HOST_LEN];
int partial_send;
int resend_msg;



#define TRUE 1
#define FALSE 0


int node_add[MAX_NODES + 1];

/* Message Types */
#define START 11
#define NORMAL 3

#define PVM_LEN 32
char * pvm_usage = "Usage: %s my_node_num\n";
char  pvm_name[PVM_LEN];
char  barrier1[PVM_LEN+1];
char  barrier2[PVM_LEN+1];


sim_exit( num )
int num;
{

	leave();
	exit ( num );
}


/* glue_init ( argc, argv)*/
main ( argc, argv)
int argc;
char *argv[];
{
	int i;
	int ret;
	char *p;

	if ( p = strrchr ( argv[0], '/' ) )
		p++;
	else
		p = argv[0];

/*
	if ( argc < 2 )
	{
		printf ( pvm_usage, p );
		exit (0);
	}
*/

	if ( *argv[1] >= '0' && *argv[1] <= '9' )
	{
		tw_node_num = atoi ( argv[1] );

		if ( tw_num_nodes > MAX_NODES )
		{
			printf ( "MAX_NODES is %d\n", MAX_NODES );
			exit ( 0 );
		}
	}
	else
	{
		printf ( pvm_usage, p );
		exit (0);
	}

/*
	printf ( "Node %d: %s\n", tw_node_num, "here i am" );
*/
	strcpy ( pvm_name, p );
	sprintf ( barrier1, "%s1", pvm_name );
	sprintf ( barrier2, "%s2", pvm_name );
/*
	printf ( "pvm_name is <%s>\n", pvm_name );
*/
	read_config_file();

	pvm_init();

	if ( tw_node_num == tw_num_nodes )
		main_host();
	else
		main_node ( argc, argv );
}


read_config_file ()
{
	int node;
	FILE * fp;

	fp = fopen ( "NODES", "r" );

	if ( fp == NULL )
	{
		printf ( "NODES file not found\n" );
		exit ();
	}

	while ( fscanf ( fp, "%d", &node ) == 1 )
	{
		fscanf ( fp, " %s", host[node] );
	}

	tw_num_nodes = node;

	fclose ( fp );

	gethostname ( sunname, HOST_LEN );
}

pvm_init()
{
	int i;
	int node, i_node;
	int pvm_i_num;

	if ( (pvm_i_num = enroll ( pvm_name )) < 0 )
	{
		printf ( "enroll failed\n" );
		exit ( 1 );
	}
	else
	{
/*
		printf ( "Node %d is Instance %d of %d\n",
			tw_node_num, pvm_i_num, tw_num_nodes );
*/
	}


	signal ( SIGINT, sim_exit );

	barrier ( barrier1, tw_num_nodes + 1 );

	if ( pvm_i_num != 0 )
	{
		initsend();
		putnint ( &tw_node_num, 1 );
		putnint ( &pvm_i_num, 1 );
		snd ( pvm_name, 0, START );
	}
	else
	{
		node_add[tw_node_num] = pvm_i_num;
		for ( i = 1; i <= tw_num_nodes; i++ )
		{
			if (rcv(-1) < 0) {
				fprintf(stderr, "rcv returned %d\n", i);
				sim_exit ( 1 );
			}

			getnint ( &node, 1 );
			getnint ( &i_node, 1 );

			node_add[node] = i_node;

		}
	}

	if ( pvm_i_num == 0 )
	{
		for ( i = 1; i <= tw_num_nodes; i++ )
		{
			initsend();
			putnint ( node_add, tw_num_nodes );
			snd ( pvm_name, i, START );
		}
	}
	else
	{
		if (rcv(-1) < 0) {
			fprintf(stderr, "rcv returned %d\n", i);
			sim_exit ( 1 );
		}

		getnint ( node_add, tw_num_nodes );
	}

	barrier ( barrier2, tw_num_nodes + 1 );
}
